<?php defined('SYSPATH') OR die('No direct access allowed.');
class Ads_Controller extends website_Controller 
{
	const ALLOW_PRODUCTION = FALSE;
	public $template = 'admin_template/template';
	public function __construct()
	{
		parent::__construct();
		if((!$this->user_id || $this->user_type != 1) && $this->uri->last_segment() != "admin-login.html"){
			url::redirect(PATH);
		} 
		include Kohana::find_file('language', "ads_".LANGUAGE);
		$cont1 = $content_text; 
		
		$this->Lang = array_merge($cont1, $this->Lang);
		
		$this->ads = new Ads_Model();
		$this->ads_act = "1";
	}
		
	/* INSERT NEW ADS */
	
	public function add_adds()
	{
		if($_POST){
			$this->AddPost = $this->input->post();
			$post = Validation::factory($_POST)
				->pre_filter('trim')
				->add_rules('ads_position', 'required', array($this,'position_exist'))
				->add_rules('add_title', 'required','chars[a-zA-Z0-9 \,.&_-]')
				->add_rules('add_code','required');
				
			if($post->validate()){
				$addCode = $this->input->raw("post",'add_code');
				$addCode = stripslashes($addCode);
				$addtitle = $this->AddPost["add_title"];
				$position = $this->AddPost["ads_position"];	
				
				$status = $this->ads->add_ads($addtitle, $addCode,$position);
				if($status == 1){
					common::message(1,$this->Lang["ADDS_ADD_SUC"]);
					url::redirect(PATH."adds_mgmt/manage_adds.html");
				}
			}
			else{
				$this->form_error = error::_error($post->errors());
			}
		}
		$this->template->title = $this->Lang["ADDS_ADD_PAGE"];
		$this->template->content = new View("add_adds");
	}
	
	/* MANAGE ADS  */
	
	public function view_adds()
	{
		$this->ad_details=$this->ads->manage_ad();
		$this->template->title=$this->Lang["MANAGE_ADD_PAGE"];
		$this->template->content=new View("manage_adds");
	}

	/* CHECK ADD IS EXIST*/
	
	public function position_exist($position = "")
	{
		$exist = $this->ads->position_exist($position);
		return ! $exist;
	}

	/* EDIT ADS */
	
	public function edit_ads($id = "")
	{
		$get_code = explode("_", $id);
		$id = $get_code[0];
		$position = $get_code[1];
			if($_POST){
				$this->AddPost = $this->input->post();
				$addCode = $this->input->raw("post",'ad_code');
				$addCode = stripslashes($addCode);
				$addtitle = $this->AddPost["ad_title"];
				$newposition = $this->AddPost["ads_position"];
				$post = Validation::factory($_POST)
						->add_rules('ad_title','required','chars[a-zA-Z0-9 \,.&_-]')
						->add_rules('ads_position', 'required')
						->add_rules('ad_code','required');
				if($post->validate()){
					$status=$this->ads->ad_update($addtitle, $addCode, $newposition, $id, $position);
					if($status == 9){
						common::message(-1,$this->Lang["ADD_POS_EXIST"]);
					}
					else{ 
						common::message(1,$this->Lang["UPD_ADD_SUC"]);
					}
					url::redirect(PATH."adds_mgmt/manage_adds.html");
				}
				else{
					$this->form_error = error::_error($post->errors());
				}
			}
		$this->get_record = $this->ads->get_one_record($id, $position);
		if(count($this->get_record)== 0){
			common::message(1,$this->Lang["RECORD_NOT"]);
			url::redirect(PATH."adds_mgmt/manage_adds.html");
		}
		$this->template->content= new View("edit_ads");
	}	
	
	/* BLOCK AND UNBLOCK ADS */

	public function block_ads($type = "", $id = "")
	{
	
                if($id){
                        $status = $this->ads->blockunblock_Ad($type, $id);
                        if($status == 1){
                                if($type == 1){
                                        common::message(1, $this->Lang["AD_UNB_SUC"]);
                                }
                                else{
                                        common::message(1, $this->Lang["AD_BL_SUC"]);
                                }
                        }
                        else{
                                common::message(-1, $this->Lang["NO_RECORD_FOUND"]);
                        }
                }
                url::redirect(PATH."adds_mgmt/manage_adds.html");
	}

	/* DELETE ADS */

	public function delete_ads($id = "")
	{
		$status = $this->ads->delete_ads($id);
		if($status == 1){
				common::message(1, $this->Lang["ADD_DEL_SUC"]);
			}
			else{
				common::message(-1, $this->Lang["NO_RECORD_FOUND"]);
			}		
		url::redirect(PATH."adds_mgmt/manage_adds.html");
	}
}


