<?php defined('SYSPATH') or die('No direct script access.');
class Home_Model extends Model
{
	public function __construct()
	{
		parent::__construct();
		$this->db = new Database();
		$this->session = Session::instance();
		$this->city_id = $this->session->get("CityID");
		$this->UserID = $this->session->get("UserID");
	}
	/* GET MODULE SETTING LIST */
	public function get_setting_module_list()
	{
		$result = $this->db->from("module_settings")->get();
		return $result;
	}
	
	/* GET BANNER LIST */
	public function get_banner_list()
	{
		$result = $this->db->from("banner_image")->where("status",1)->get();
		return $result;
	}
	
	/* GET ADS LIST */
	public function get_ads_list()
	{
		$result = $this->db->from("ads")->where(array("status" => 1))->get();
		return $result;
	}
		
	/** GET THE IMAGE RESIZE DATA LIST  AND THIS FUNCTION USED IN WEBSITE CONTROLLER **/

	public function get_image_resize_data($type = "")
	{
		$result = $this->db->getwhere("image_resize",array("type" => $type)); 
		return $result;
	}
       /** GET PRODUCTS DETAILS **/

	public function products_details($cityid="")
	{
		if(CITY_SETTING){
			$result = $this->db->query("select * from product join category on category.category_id=product.category_id  where deal_status = 1 and purchase_count < user_limit_quantity and category.category_status =1 order by deal_id DESC limit 8 ");
	        return $result;
		} else {
			$result = $this->db->query("select * from product join category on category.category_id=product.category_id  where deal_status = 1 and purchase_count < user_limit_quantity  and category.category_status =1 order by deal_id DESC limit 8 ");
	        return $result;
		}
	}
	
	       /** GET PRODUCTS DETAILS **/

	public function products_details1($cityid="")
	{
		if(CITY_SETTING){
			$result = $this->db->query("select * from product join category on category.category_id=product.category_id  where deal_status = 1 and purchase_count < user_limit_quantity  and category.category_status =1  order by deal_id DESC ");
	         return count($result);
		} else {
			$result = $this->db->query("select * from product join category on category.category_id=product.category_id  where deal_status = 1 and purchase_count < user_limit_quantity  and category.category_status =1  order by deal_id DESC  ");
	        return count($result);
		}
	}
  /** GET HOT PRODUCTS DETAILS **/

	public function hot_products_details()
	{
		
			$result = $this->db->query("select * from product join category on category.category_id=product.category_id  where deal_status = 1 and purchase_count < user_limit_quantity and deal_feature = 1  and category.category_status =1  order by deal_id DESC");
			
	        return $result;
		
	}
		
	/** GET CITY LIST JOIN COUNTRY **/

	public function get_all_city_list()
	{
		$result = $this->db->from("city")->join("country","country.country_id","city.country_id")->where(array("city_status" => 1,"country_status" => 1))->orderby("city_name", "ASC")->get();
		return $result;
	}
	
	/** GET COUNTRY LIST JOIN COUNTRY **/

	public function get_all_country_list()
	{
		$result = $this->db->from("country")->where(array("country_status" => 1))->orderby("country_name", "ASC")->get();
		return $result;
	}


	/** ADD SUBSCRIBE TO USER EMAIL ADDRESS **/

	public function add_user_subscribe($email = "", $city_data = "")
	{
		if(CITY_SETTING) {
			$Cdata = explode("_", $city_data);
			if(isset($Cdata[0]) && isset($Cdata[1])){
				
				$result = $this->db->count_records("email_subscribe", array("email_id" =>  $email));
				if($result == 0){
					
					$status = $this->db->insert("email_subscribe", array("email_id" => $email, "country_id" => $Cdata[0] , "city_id" => $Cdata[1]));
					return $Cdata[1];
				} elseif($result == 1) {
					$status = $this->db->update("email_subscribe", array("country_id" => $Cdata[0] , "city_id" => $Cdata[1]),array("email_id" =>$email,"country_id"=>"","city_id" =>""));
					return $Cdata[1];
				}
				return $Cdata[1];
			}
			return -1;
		} else {
			$result = $this->db->count_records("email_subscribe", array("email_id" =>  $email));
				if($result == 0){
					$status = $this->db->insert("email_subscribe", array("email_id" => $email));
					return $status;
				}
				return 0;
		}
	}


	/* PAYMENT LIST  */
	   public function payment_list1()
	{
		$result = $this->db->select("users.firstname","bidding_time as transaction_date","bidding.bid_amount","auction_id")->from("bidding")->join("auction", "auction.deal_id", "bidding.auction_id")->join("users","users.user_id","bidding.user_id")->get(); 
		//$result = $this->db->from("transaction")->join("users","users.user_id","transaction.user_id")->where(array("bid_amount !=" => 0))->orderby("id","ASC")->get(); 
		return $result;
	}

		/** GET DEALS CATEGORY LIST **/
	
	public function get_category_list($product="")
	{ 
		$condition = " category_status = 1 AND main_category_id = 0";

		if($product == 1){
			$condition .= " AND product = 1 ";
		}

		if($product == 0){
			return 0;
		}

		$result = $this->db->query("select * from category where $condition order by category_name ASC"); 
		
		return $result;
	}
	/** GET DEALS CATEGORY LIST **/
	
	public function get_all_category_list()
	{
		$result = $this->db->from("category")->where(array("category_status" => 1))->orderby("category_name","ASC")->get();
		return $result;
	}
	/** GET DEALS SUB CATEGORY LIST **/
	
	public function get_sub_category_list()
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"main_category_id !="=>0))->orderby("category_name","ASC")->get();
		return $result;
	}

	
	/** CHECK CITY EXIST **/

	public function check_city_exist($City = "")
	{
		$result = $this->db->count_records("city", array("city_name" => $City[0], "city_id" => $City[1], "city_status" => 1));
		return $result;
	}

	
	/** GET ABOUT US DATA **/

	public function get_cms_data($url = "")
	{
		$result = $this->db->from("cms")->where(array("cms_url" => $url, "cms_status" => 1))->limit(1)->get();
		return $result;

	}

	/** GET CMS TITLES **/

	public function get_all_cms_page()
	{
		$result = $this->db->from("cms")->where(array("cms_status" => 1,"type !=" => 1))->get();
		
		return $result;
	}

	/** ABOUT US PAGE **/

	public function abou_us_page()
	{
		$result = $this->db->from("cms")->where(array("type" => 1))->limit(1)->get();
		return $result;
	}

	/** CONTACT US **/

	public function contact_us_details($post)
	{

		$result = $this->db->insert("contact", array("name" =>$post->name, "email" => $post->email, "phone_number" => $post->phone, "message" => $post->message));
			if($result){
			$message = "Name :".ucfirst($post->name)."<br /><br />Email :".$post->email."<br /><br /> Message :<br />".$post->message;
			$from = CONTACT_EMAIL;
			if(THEME_NAME==2){
			email::smtp($post->email,CONTACT_EMAIL, "Customer Inquiry", $message);
			}else{
			email::sendgrid($post->email,CONTACT_EMAIL, "Customer Inquiry", $message);
			}
			return 1;
			}
			else{
			return 0;
			}
	}

	/** GET UNSUBSCRIBER DATA **/

	public function get_unsubscribed_user($id = "")
	{
		$result = $this->db->from("users")->where(array("user_id" => $id))->get();
		return $result;
	}

	/** UNSUBSCRIBE UPDATE **/

	public function unsubscriber_update($id = "")
	{
		$result = $this->db->update("users", array("newsletter_deals" => 0 ),array("user_id" => $id));
		return 1;
	}

	/** SUBSCRIBER CONFIRMATION **/

	public function confirm_newsletter($mail = "")
	{
		$result = $this->db->update("email_subscribe", array("confirm_status" => 1), array("email_address" => $mail));
		return 1;
	}

	/** GET RSS DEALS LIST  **/

	public function get_rss_deals_lists($city_id = "")
	{
	
		$result = $this->db->query("select * from product join category on category.category_id=product.category_id  where  deal_status = 1 and category.category_status = 1  order by product.created_date DESC");
		
	        return $result;
	}
	
	
	/**UPDATE THEME COLOR  **/

	public function change_theme_colour($theme = "")
	{
		$status = $this->db->update("settings",array("theme" => $theme),array("id" => 1));
		return 1;
	}
	
	/** GET ADDS CODE  **/

	public function get_ads_code()
	{
		$result = $this->db->from("ads")->where(array("status" => 1))->get();
		return $result;
	}

	/** GET COPY RIGHT  **/
	public function get_copy_right()
	{
		$result = $this->db->from("cms")->where(array("cms_id" => 8))->get();
		return $result;
	}
	
	/** GET ALL SETTINGS DATA**/

	public function get_all_settings_data()
	{
		$result = $this->db->from("settings")->limit(1)->get();
		return $result;
	}
	
	/** GET CITY  LIST**/
	public function get_city_by_country($country_id){
		$result = $this->db->from("city")->where(array("country_id" => $country_id))->orderby("city_name")->get();
		return $result;
	}
	
	/** GET AFFILIATE URL INPUT - SHORT URL  **/

	public function get_aff_url($deal_id = "", $deal_key = "")
	{
		$result = $this->db->select("url_title")->from("deals")->where(array("deal_id" => $deal_id, "deal_key" => $deal_key, "deal_status" => 1))->get();
		return $result;
	}


	/** GET FAQ COUNT **/
	
	public function get_count()
	{
		$result = $this->db->from("faq")->where('faq_status',1)->get();
		return count($result);
	}	
	/* GET FAQ */
	public function get_all_faq($offset = "", $record = "")
	{
		$result = $this->db->from("faq")->where(array("faq_status" => 1))->orderby("faq_id","DESC")->limit($record,$offset)->get();
		
		return $result;
	}

		/** GET DEALS SUB CATEGORY LIST **/
	
	public function get_subcategory_list($id="")
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"main_category_id !="=>0,"main_category_id"=>$id))->orderby("category_name","ASC")->get();
		return $result;
	}
	/* PAYMENT LIST */
	        public function payment_list()
	    {
			$result = $this->db->select("users.firstname","bidding_time as transaction_date","bidding.bid_amount","auction_id")->from("bidding")->join("auction", "auction.deal_id", "bidding.auction_id")->join("users","users.user_id","bidding.user_id")->get(); 
		    //$result = $this->db->from("transaction")->join("users","users.user_id","transaction.user_id")->where(array("bid_amount !=" => 0))->orderby("id","ASC")->get(); 
		    return $result;
	    }
	    
		/** GET SEARCH PRODUCTS LIST **/
	public function  get_search_products_list($search = "", $category = "",$cat_type="")
	{
		
		  $conditions = " ";
	        $join = "category_mapping.map_main_category_id";
	 		if($category && $cat_type=='main') {
			
			$conditions .= " and category.category_id=$category ";
		}elseif($category && $cat_type=='sub') {
			$conditions .= " and category.category_id=$category ";
			$join = "category_mapping.map_category_id";
		}
		if($search){
			$conditions .= " and (deal_title like '%".mysql_escape_string($search)."%'";
			$conditions .= " or deal_description like '%".mysql_escape_string($search)."%')";
		}

		if(CITY_SETTING){ 
		
		$query = "select * from product join category_mapping on category_map_deal_id=product.deal_id join category on category.category_id=$join join product_size on product_size.deal_id=product.deal_id where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and stores.city_id = '$this->city_id' and category_mapping.category_type = 2  $conditions group by product.deal_id order by product.deal_id DESC "; 
		$result = $this->db->query($query);
	       
	        
		} else {
			
			$query = "select * from product join category_mapping on category_map_deal_id=product.deal_id join category on category.category_id=$join join product_size on product_size.deal_id=product.deal_id where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and category_mapping.category_type = 2  $conditions group by product.deal_id order by product.deal_id DESC "; 
			$result = $this->db->query($query);
			
	       
		} 
		
		 return $result;
	}
	
	/** GET COMMENTS LIST **/

	public function get_comments_data($deal_id = "",$type = "")
	{
                               
		$result = $this->db->from("discussion")
						   ->join("users","users.user_id","discussion.user_id")
						   ->where(array("deal_id" => $deal_id,"discussion_status" => "1","delete_status" => 1,"type" =>$type))->orderby("discussion_id", "DESC")->get();
		return $result;
	}
	
	/** GET LIKE COUNT **/
	
	public function get_like_data($deal_id = "",$type = "")
	{
		$result = $this->db->from('discussion_likes')->where(array('deal_id' => $deal_id,"type" =>$type))->get();
		return $result;
	}
	
	/** GET UNLIKE COUNT **/
	
	public function get_unlike_data($deal_id = "",$type = "")
	{
		$result = $this->db->from('discussion_unlike')->where(array('deal_id' => $deal_id,"type" =>$type))->get();
		return $result;
	}
    
    /**COUNT LIKE  **/

    public function like1($deal_id = "",$user_id="",$dis_id = "",$type = "")
    { 
            $result = $this->db->insert("discussion_likes",array("discussion_id" => $dis_id, "deal_id" => $deal_id,"type" =>$type, "user_id" => $this->session->get('UserID')));
            $result = $this->db->from('discussion_unlike')->where(array("discussion_id" => $dis_id, "deal_id" => $deal_id, "type" =>$type,"user_id" => $this->session->get('UserID')))->get();
            if(count($result) > 0){
				$result = $this->db->delete('discussion_unlike', array("discussion_id" => $dis_id, "deal_id" => $deal_id, "type" =>$type,"user_id" => $this->session->get('UserID')));
			}
            return 1;
    }
    /* UNLIKE COUNT */
     public function unlike1($deal_id = "",$user_id="",$dis_id = "",$type = "")
    { 
            $result = $this->db->insert("discussion_unlike",array("discussion_id" => $dis_id, "deal_id" => $deal_id,"type" =>$type, "user_id" => $this->session->get('UserID')));
            $result = $this->db->from('discussion_likes')->where(array("discussion_id" => $dis_id, "deal_id" => $deal_id, "type" =>$type,"user_id" => $this->session->get('UserID')))->get();
            if(count($result) > 0){
				$result = $this->db->delete('discussion_likes', array("discussion_id" => $dis_id, "deal_id" => $deal_id,"type" =>$type, "user_id" => $this->session->get('UserID')));
			}
            return 1;
    }
    
	/** ADD COMMENTS **/

	public function add_comments($comments = "" , $deal_id = "",$type= "")
	{
	        $result = $this->db->insert("discussion", array("user_id" =>$this->UserID, "deal_id" => $deal_id, "comments" => $comments,"type" =>$type,"created_date" => time()));
			
		return $result->insert_id(); 
	}
	/** GET DEALS LIKE COUNT **/
	
	public function get_like_details($dis_id = "",$type = "")
	{
		$result = $this->db->from('discussion_likes')->where(array('discussion_id' => $dis_id,"type" => $type))->get();
		return count($result);
	}
	/* GET UNLIKE DETAILS */
	public function get_unlike_details($dis_id = "",$type = "")
	{
		$result = $this->db->from('discussion_unlike')->where(array('discussion_id' => $dis_id,"type" => $type))->get();
		return count($result);
	}
	/* GET SUB CATEGORY COUNT */
		public function get_subcat_count($cat_id = "")
	{
		return $this->db->count_records("category",array("main_category_id" => $cat_id,"category_status" => 1));
	}
}
